/** Main file for USB storage key **/

#include <avr/io.h>
#include <util/delay.h>

#define LED_DIR		DDRB
#define LED_PORT	PORTB
#define LED_BIT 	7

#define NB_ROWS 4
#define NB_COLS  5

#define DELAY_BIT 200

void oneblink(void);
volatile unsigned char *cols_d[NB_COLS]={&DDRD,&DDRD,&DDRD,&DDRB,&DDRB};
volatile unsigned char *cols_p[NB_COLS]={&PORTD,&PORTD,&PORTD,&PORTB,&PORTB};
volatile unsigned char *cols_i[NB_COLS]={&PIND,&PIND,&PIND,&PINB,&PINB};
int cols_n[NB_COLS]={4,5,6,0,3};

volatile unsigned char *rows_d[NB_ROWS]={&DDRD,&DDRD,&DDRD,&DDRD};
volatile unsigned char *rows_p[NB_ROWS]={&PORTD,&PORTD,&PORTD,&PORTD};
int rows_n[NB_ROWS]={0,1,2,3};


void setup() {

CLKSEL0 = 0b00010101;   // sélection de l'horloge externe
CLKSEL1 = 0b00001111;   // minimum de 8Mhz
CLKPR = 0b10000000;     // modification du divise  if(*cols_i[0] & (1<<cols_n[0])) LED_PORT &= ~(1<<5); else LED_PORT |= (1<<5);ur d'horloge (CLKPCE=1)
CLKPR = 0;              // 0 pour pas de diviseur (diviseur de 1)

LED_DIR |= (1<<5);
LED_PORT &= ~(1<<5);

for(int col=0;col<NB_COLS;col++){
  *cols_d[col] &= ~(1<<cols_n[col]);
  *cols_p[col] |= (1<<cols_n[col]);
  }  
for(int row=0;row<NB_ROWS;row++){
  *rows_d[row] |= (1<<rows_n[row]);
  *rows_p[row] |= (1<<rows_n[row]);
};

}

void oneblink(void){
LED_PORT |= (1<<5);
_delay_ms(DELAY_BIT);
LED_PORT &= ~(1<<5);
_delay_ms(DELAY_BIT);
}

void nblink(int n){
for(int i=0;i<8;i++){
  int nb;
  if(n & (1<<i)) nb=2; else nb=1;
  for(int j=0;j<nb;j++) oneblink(); 
  _delay_ms(1000);
  }
}

void loop() {
for(int row=0;row<NB_ROWS;row++){
  *rows_p[row] &= ~(1<<rows_n[row]);
  for(int col=0;col<NB_COLS;col++){
	unsigned char key = (*cols_i[col] & (1<<cols_n[col]))?0:1;
    if (key) nblink((row+1)*(col+1));
	};
  *rows_p[row] |= (1<<rows_n[row]);
  };
}

int main(void){
setup();
while(1) loop();
}

//
